/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 5-3 */

 1 #include <sys/stat.h>
 2 #include <fcntl.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int numBytes, j, flags, fd;
 9     Boolean useLseek;
10
11     if (argc < 3 || strcmp(argv[1], "--help") == 0)
12         usageErr("%s file num-bytes [x]\n"
13                  "        'x' means use lseek() instead of O_APPEND\n",
14                  argv[0]);
15
16     useLseek = argc > 3;
17     flags = useLseek ? 0 : O_APPEND;
18     numBytes = getInt(argv[2], 0, "num-bytes");
19
20     fd = open(argv[1], O_RDWR | O_CREAT | flags, S_IRUSR | S_IWUSR);
21     if (fd == -1)
22         errExit("open");
23
24     for (j = 0; j < numBytes; j++) {
25         if (useLseek)
26             if (lseek(fd, 0, SEEK_END) == -1)
27                 errExit("lseek");
28         if (write(fd, "x", 1) != 1)
29             fatal("write() failed");
30     }
31
32     printf("%ld done\n", (long) getpid());
33     exit(EXIT_SUCCESS);
34 }
