/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 15 */

 1 #include <sys/stat.h>
 2 #include <utime.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     char *pathname;
 9     struct stat sb;
10     struct utimbuf utb;
11
12     if (argc != 2 || strcmp(argv[1], "--help") == 0)
13         usageErr("%s file\n", argv[0]);
14
15     pathname = argv[1];
16
17     if (stat(pathname, &sb) == -1)    /* Retrieve current file times */
18         errExit("stat");
19
20     utb.actime = sb.st_atime;         /* Leave access time unchanged */
21     utb.modtime = sb.st_atime;        /* Make modify time same as access time */
22     if (utime(pathname, &utb) == -1)  /* Update file times */
23         errExit("utime");
24
25     exit(EXIT_SUCCESS);
26 }
