/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Lesser General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
\*************************************************************************/

/* Supplementary program for Chapter 3 */

 1 #include <stdio.h>
 2 #include <fcntl.h>
 3 #include "alt_functions.h"
 4
 5 /* A very minimal implementation of strsignal()... */
 6
 7 #define BUF_SIZE 100
 8
 9 char *
10 ALT_strsignal(int sig)
11 {
12     static char buf[BUF_SIZE];          /* Not thread-safe */
13
14     snprintf(buf, BUF_SIZE, "SIG-%d", sig);
15     return buf;
16 }
17
18 /* A very minimal implementation of hstrerror()... */
19
20 char *
21 ALT_hstrerror(int err)
22 {
23     static char buf[BUF_SIZE];          /* Not thread-safe */
24
25     snprintf(buf, BUF_SIZE, "hstrerror-%d", err);
26     return buf;
27 }
28
29 /* posix_openpt() is simple to implement */
30
31 int
32 ALT_posix_openpt(int flags)
33 {
34     return open("/dev/ptmx", flags);
35 }
