 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10 
11 /* Listing 47-9 */
12 
13  1 #ifndef BINARY_SEMS_H           /* Prevent accidental double inclusion */
14  2 #define BINARY_SEMS_H
15  3
16  4 #include "tlpi_hdr.h"
17  5
18  6 /* Variables controlling operation of functions below */
19  7
20  8 extern Boolean bsUseSemUndo;            /* Use SEM_UNDO during semop()? */
21  9 extern Boolean bsRetryOnEintr;          /* Retry if semop() interrupted by
22 10                                            signal handler? */
23 11
24 12 int initSemAvailable(int semId, int semNum);
25 13
26 14 int initSemInUse(int semId, int semNum);
27 15
28 16 int reserveSem(int semId, int semNum);
29 17
30 18 int releaseSem(int semId, int semNum);
31 19
32 20 #endif
