 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10
11 /* Listing 10-2 */
12
13  1 #include <time.h>
14  2 #include "curr_time.h"          /* Declares function defined here */
15  3
16  4 #define BUF_SIZE 1000
17  5
18  6 /* Return a string containing the current time formatted according to
19  7    the specification in 'format' (see strftime(3) for specifiers).
20  8    If 'format' is NULL, we use "%c" as a specifier (which gives the'
21  9    date and time as for ctime(3), but without the trailing newline).
22 10    Returns NULL on error. */
23 11
24 12 char *
25 13 currTime(const char *format)
26 14 {
27 15     static char buf[BUF_SIZE];  /* Nonreentrant */
28 16     time_t t;
29 17     size_t s;
30 18     struct tm *tm;
31 19
32 20     t = time(NULL);
33 21     tm = localtime(&t);
34 22     if (tm == NULL)
35 23         return NULL;
36 24
37 25     s = strftime(buf, BUF_SIZE, (format != NULL) ? format : "%c", tm);
38 26
39 27     return (s == 0) ? NULL : buf;
40 28 }
