/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Lesser General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
\*************************************************************************/

/* Listing 3-2 */

 1 #ifndef ERROR_FUNCTIONS_H
 2 #define ERROR_FUNCTIONS_H
 3 
 4 void errMsg(const char *format, ...);
 5 
 6 #ifdef __GNUC__
 7 
 8     /* This macro stops 'gcc -Wall' complaining that "control reaches
 9        end of non-void function" if we use the following functions to
10        terminate main() or some other non-void function. */
11 
12 #define NORETURN __attribute__ ((__noreturn__))
13 #else
14 #define NORETURN
15 #endif
16 
17 void errExit(const char *format, ...) NORETURN ;
18 
19 void err_exit(const char *format, ...) NORETURN ;
20 
21 void errExitEN(int errnum, const char *format, ...) NORETURN ;
22 
23 void fatal(const char *format, ...) NORETURN ;
24 
25 void usageErr(const char *format, ...) NORETURN ;
26 
27 void cmdLineErr(const char *format, ...) NORETURN ;
28 
29 #endif
