 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10
11 /* Listing 23-6 */
12
13  1 #include <string.h>
14  2 #include <stdlib.h>
15  3 #include "itimerspec_from_str.h"        /* Declares function defined here */
16  4
17  5 /* Convert a string of the following form to an itimerspec structure:
18  6    "value.sec[/value.nanosec][:interval.sec[/interval.nanosec]]".
19  7    Optional components that are omitted cause 0 to be assigned to the
20  8    corresponding structure fields. */
21  9
22 10 void
23 11 itimerspecFromStr(char *str, struct itimerspec *tsp)
24 12 {
25 13     char *dupstr ,*cptr, *sptr;
26 14
27 15     dupstr = strdup(str);
28 16
29 17     cptr = strchr(dupstr, ':');
30 18     if (cptr != NULL)
31 19         *cptr = '\0';
32 20
33 21     sptr = strchr(dupstr, '/');
34 22     if (sptr != NULL)
35 23         *sptr = '\0';
36 24
37 25     tsp->it_value.tv_sec = atoi(dupstr);
38 26     tsp->it_value.tv_nsec = (sptr != NULL) ? atoi(sptr + 1) : 0;
39 27
40 28     if (cptr == NULL) {
41 29         tsp->it_interval.tv_sec = 0;
42 30         tsp->it_interval.tv_nsec = 0;
43 31     } else {
44 32         sptr = strchr(cptr + 1, '/');
45 33         if (sptr != NULL)
46 34             *sptr = '\0';
47 35         tsp->it_interval.tv_sec = atoi(cptr + 1);
48 36         tsp->it_interval.tv_nsec = (sptr != NULL) ? atoi(sptr + 1) : 0;
49 37     }
50 38     free(dupstr);
51 39 }
