 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10
11 /* Solution for Exercise 36-2:b */
12
13  1 #include <sys/resource.h>
14  2 #include "print_rusage.h"
15  3 #include "tlpi_hdr.h"
16  4
17  5 void
18  6 printRusage(const char *leader, const struct rusage *ru)
19  7 {
20  8     const char *ldr;
21  9
22 10     ldr = (leader == NULL) ? "" : leader;
23 11
24 12     printf("%sCPU time (secs):         user=%.3f; system=%.3f\n", ldr,
25 13             ru->ru_utime.tv_sec + ru->ru_utime.tv_usec / 1000000.0,
26 14             ru->ru_stime.tv_sec + ru->ru_stime.tv_usec / 1000000.0);
27 15     printf("%sMax resident set size:   %ld\n", ldr, ru->ru_maxrss);
28 16     printf("%sIntegral shared memory:  %ld\n", ldr, ru->ru_ixrss);
29 17     printf("%sIntegral unshared data:  %ld\n", ldr, ru->ru_idrss);
30 18     printf("%sIntegral unshared stack: %ld\n", ldr, ru->ru_isrss);
31 19     printf("%sPage reclaims:           %ld\n", ldr, ru->ru_minflt);
32 20     printf("%sPage faults:             %ld\n", ldr, ru->ru_majflt);
33 21     printf("%sSwaps:                   %ld\n", ldr, ru->ru_nswap);
34 22     printf("%sBlock I/Os:              input=%ld; output=%ld\n",
35 23             ldr, ru->ru_inblock, ru->ru_oublock);
36 24     printf("%sSignals received:        %ld\n", ldr, ru->ru_nsignals);
37 25     printf("%sIPC messages:            sent=%ld; received=%ld\n",
38 26             ldr, ru->ru_msgsnd, ru->ru_msgrcv);
39 27     printf("%sContext switches:        voluntary=%ld; "
40 28             "involuntary=%ld\n", ldr, ru->ru_nvcsw, ru->ru_nivcsw);
41 29 }
