/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 49-1 */

 1 #include <sys/mman.h>
 2 #include <sys/stat.h>
 3 #include <fcntl.h>
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     char *src, *dst;
10     int fdSrc, fdDst;
11     struct stat sb;
12
13     if (argc != 3)
14         usageErr("%s source-file dest-file\n", argv[0]);
15
16     fdSrc = open(argv[1], O_RDONLY);
17     if (fdSrc == -1)
18         errExit("open");
19
20     /* Use fstat() to obtain size of file: we use this to specify the
21        size of the two mappings */
22
23     if (fstat(fdSrc, &sb) == -1)
24         errExit("fstat");
25
26     /* Handle zero-length file specially, since specifying a size of
27        zero to mmap() will fail with the error EINVAL */
28
29     if (sb.st_size == 0)
30         exit(EXIT_SUCCESS);
31
32     src = mmap(NULL, sb.st_size, PROT_READ, MAP_PRIVATE, fdSrc, 0);
33     if (src == MAP_FAILED)
34         errExit("mmap");
35
36     fdDst = open(argv[2], O_RDWR | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR);
37     if (fdDst == -1)
38         errExit("open");
39
40     if (ftruncate(fdDst, sb.st_size) == -1)
41         errExit("ftruncate");
42
43     dst = mmap(NULL, sb.st_size, PROT_READ | PROT_WRITE, MAP_SHARED, fdDst, 0);
44     if (dst == MAP_FAILED)
45         errExit("mmap");
46
47     memcpy(dst, src, sb.st_size);       /* Copy bytes between mappings */
48     if (msync(dst, sb.st_size, MS_SYNC) == -1)
49         errExit("msync");
50
51     exit(EXIT_SUCCESS);
52 }
