/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 34-3 */

 1 #define _XOPEN_SOURCE 500
 2 #include <unistd.h>
 3 #include <signal.h>
 4 #include "tlpi_hdr.h"
 5
 6 static void
 7 handler(int sig)
 8 {
 9 }
10
11 int
12 main(int argc, char *argv[])
13 {
14     pid_t childPid;
15     struct sigaction sa;
16
17     setbuf(stdout, NULL);       /* Make stdout unbuffered */
18
19     sigemptyset(&sa.sa_mask);
20     sa.sa_flags = 0;
21     sa.sa_handler = handler;
22     if (sigaction(SIGHUP, &sa, NULL) == -1)
23         errExit("sigaction");
24
25     childPid = fork();
26     if (childPid == -1)
27         errExit("fork");
28
29     if (childPid == 0 && argc > 1)
30         if (setpgid(0, 0) == -1)        /* Move to new process group */
31             errExit("setpgid");
32
33     printf("PID=%ld; PPID=%ld; PGID=%ld; SID=%ld\n", (long) getpid(),
34             (long) getppid(), (long) getpgrp(), (long) getsid(0));
35
36     alarm(60);                  /* An unhandled SIGALRM ensures this process
37                                    will die if nothing else terminates it */
38     for(;;) {                   /* Wait for signals */
39         pause();
40         printf("%ld: caught SIGHUP\n", (long) getpid());
41     }
42 }
