/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 34-2 */

 1 #define _XOPEN_SOURCE 500
 2 #include <unistd.h>
 3 #include <fcntl.h>
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     if (fork() != 0)            /* Exit if parent, or on error */
10         _exit(EXIT_SUCCESS);
11
12     if (setsid() == -1)
13         errExit("setsid");
14
15     printf("PID=%ld, PGID=%ld, SID=%ld\n", (long) getpid(),
16             (long) getpgrp(), (long) getsid(0));
17
18     if (open("/dev/tty", O_RDWR) == -1)
19         errExit("open /dev/tty");
20     exit(EXIT_SUCCESS);
21 }
