/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 44-6 */

 1 #include <sys/types.h>
 2 #include <sys/stat.h>
 3 #include <fcntl.h>
 4 #include "tlpi_hdr.h"
 5 
 6 #define SERVER_FIFO "/tmp/seqnum_sv"
 7                                 /* Well-known name for server's FIFO */
 8 #define CLIENT_FIFO_TEMPLATE "/tmp/seqnum_cl.%ld"
 9                                 /* Template for building client FIFO name */
10 #define CLIENT_FIFO_NAME_LEN (sizeof(CLIENT_FIFO_TEMPLATE) + 20)
11                                 /* Space required for client FIFO pathname
12                                   (+20 as a generous allowance for the PID) */
13 
14 struct request {                /* Request (client --> server) */
15     pid_t pid;                  /* PID of client */
16     int seqLen;                 /* Length of desired sequence */
17 };
18 
19 struct response {               /* Response (server --> client) */
20     int seqNum;                 /* Start of sequence */
21 };
