/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 6-2 */

 1 #include <setjmp.h>
 2 #include "tlpi_hdr.h"
 3
 4 static jmp_buf env;     /* Global buffer for saving environment */
 5
 6 static void
 7 doJump(void)
 8 {
 9     printf("Entered doJump\n");
10     longjmp(env, 2);
11     printf("Exiting doJump\n");
12 }
13
14 static void
15 setJump2(void)
16 {
17     printf("Entered setJump2\n");
18     setjmp(env);
19     printf("Exiting setJump2\n");
20 }
21
22 static void
23 setJump(void)
24 {
25
26     printf("Entered setJump\n");
27     setJump2();
28     printf("Exiting setJump\n");
29 }
30
31 static void
32 recur(int n)
33 {
34     printf("Entered recur %d\n", n);
35     if (n > 0)
36         recur(n - 1);
37     printf("Exiting recur %d\n", n);
38 }
39
40 int
41 main(int argc, char *argv[])
42 {
43     setJump();
44     if (argc > 1)
45         recur(2);
46     doJump();
47     printf("Back at main\n");
48
49     exit(EXIT_SUCCESS);
50 }
