/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 6-5 */

 1 #include <setjmp.h>
 2 #include "tlpi_hdr.h"
 3
 4 static jmp_buf env;
 5
 6 static void
 7 f2(void)
 8 {
 9     longjmp(env, 2);
10 }
11
12 static void
13 f1(int argc)
14 {
15     if (argc == 1)
16         longjmp(env, 1);
17     f2();
18 }
19
20 int
21 main(int argc, char *argv[])
22 {
23     switch (setjmp(env)) {
24     case 0:     /* This is the return after the initial setjmp() */
25         printf("Calling f1() after initial setjmp()\n");
26         f1(argc);               /* Never returns... */
27         break;                  /* ... but this is good form */
28
29     case 1:
30         printf("We jumped back from f1()\n");
31         break;
32
33     case 2:
34         printf("We jumped back from f2()\n");
35         break;
36     }
37
38     exit(EXIT_SUCCESS);
39 }
