/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 6-6 */

 1 #include <stdio.h>
 2 #include <stdlib.h>
 3 #include <setjmp.h>
 4
 5 static jmp_buf env;
 6
 7 static void
 8 doJump(int nvar, int rvar, int vvar)
 9 {
10     printf("Inside doJump(): nvar=%d rvar=%d vvar=%d\n", nvar, rvar, vvar);
11     longjmp(env, 1);
12 }
13
14 int
15 main(int argc, char *argv[])
16 {
17     int nvar;
18     register int rvar;          /* Allocated in register if possible */
19     volatile int vvar;          /* See text */
20
21     nvar = 111;
22     rvar = 222;
23     vvar = 333;
24
25     if (setjmp(env) == 0) {     /* Code executed after setjmp() */
26         nvar = 777;
27         rvar = 888;
28         vvar = 999;
29         doJump(nvar, rvar, vvar);
30
31     } else {                    /* Code executed after longjmp() */
32
33         printf("After longjmp(): nvar=%d rvar=%d vvar=%d\n", nvar, rvar, vvar);
34     }
35
36     exit(EXIT_SUCCESS);
37 }
