/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 27-6 */

 1 #include <fcntl.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     int flags;
 8
 9     if (argc > 1) {
10         flags = fcntl(STDOUT_FILENO, F_GETFD);              /* Fetch flags */
11         if (flags == -1)
12             errExit("fcntl - F_GETFD");
13
14         flags |= FD_CLOEXEC;                    /* Turn on FD_CLOEXEC */
15
16         if (fcntl(STDOUT_FILENO, F_SETFD, flags) == -1)     /* Update flags */
17             errExit("fcntl - F_SETFD");
18     }
19
20     execlp("ls", "ls", "-l", argv[0], (char *) NULL);
21     errExit("execlp");
22 }
