/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 26-4 */

 1 #include <signal.h>
 2 #include <libgen.h>             /* For basename() declaration */
 3 #include "tlpi_hdr.h"
 4
 5 #define CMD_SIZE 200
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     char cmd[CMD_SIZE];
11     pid_t childPid;
12
13     setbuf(stdout, NULL);       /* Disable buffering of stdout */
14
15     printf("Parent PID=%ld\n", (long) getpid());
16
17     switch (childPid = fork()) {
18     case -1:
19         errExit("fork");
20
21     case 0:     /* Child: immediately exits to become zombie */
22         printf("Child (PID=%ld) exiting\n", (long) getpid());
23         _exit(EXIT_SUCCESS);
24
25     default:    /* Parent */
26         sleep(3);               /* Give child a chance to start and exit */
27         snprintf(cmd, CMD_SIZE, "ps | grep %s", basename(argv[0]));
28         system(cmd);            /* View zombie child */
29
30         /* Now send the "sure kill" signal to the zombie */
31
32         if (kill(childPid, SIGKILL) == -1)
33             errMsg("kill");
34         sleep(3);               /* Give child a chance to react to signal */
35         printf("After sending SIGKILL to zombie (PID=%ld):\n", (long) childPid);
36         system(cmd);            /* View zombie child again */
37
38         exit(EXIT_SUCCESS);
39     }
40 }
