/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 26-1 */

 1 #include "tlpi_hdr.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     pid_t ppid;
 7
 8     setbuf(stdout, NULL);       /* Disable buffering of stdout */
 9
10     switch (fork()) {
11     case -1:
12         errExit("fork");
13
14     case 0:             /* Child */
15         while ((ppid = getppid()) != 1) {   /* Loop until orphaned */
16             printf("Child running (parent PID=%ld)\n", (long) ppid);
17             sleep(1);
18         }
19         printf("Child is orphaned (parent PID=%ld)\n", (long) ppid);
20         _exit(EXIT_SUCCESS);
21
22     default:            /* Parent */
23         printf("Parent (PID=%ld) sleeping\n", (long) getpid());
24         sleep(3);                           /* Give child a chance to start */
25         printf("Parent exiting\n");
26         exit(EXIT_SUCCESS);
27     }
28 }
