/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 27-8 */

 1 #include <unistd.h>
 2 #include <sys/wait.h>
 3 #include <sys/types.h>
 4
 5 int
 6 system(char *command)
 7 {
 8     int status;
 9     pid_t childPid;
10
11     switch (childPid = fork()) {
12     case -1: /* Error */
13         return -1;
14
15     case 0: /* Child */
16         execl("/bin/sh", "sh", "-c", command, (char *) NULL);
17         _exit(127);                     /* Failed exec */
18
19     default: /* Parent */
20         if (waitpid(childPid, &status, 0) == -1)
21             return -1;
22         else
23             return status;
24     }
25 }
