/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 27-7 */

 1 #include <sys/wait.h>
 2 #include "print_wait_status.h"
 3 #include "tlpi_hdr.h"
 4
 5 #define MAX_CMD_LEN 200
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     char str[MAX_CMD_LEN];      /* Command to be executed by system() */
11     int status;                 /* Status return from system() */
12
13     for (;;) {                  /* Read and execute a shell command */
14         printf("Command: ");
15         fflush(stdout);
16         if (fgets(str, MAX_CMD_LEN, stdin) == NULL)
17             break;              /* end-of-file */
18
19         status = system(str);
20         printf("system() returned: status=0x%04x (%d,%d)\n",
21                 (unsigned int) status, status >> 8, status & 0xff);
22
23         if (status == -1) {
24             errExit("system");
25         } else {
26             if (WIFEXITED(status) && WEXITSTATUS(status) == 127)
27                 printf("(Probably) could not invoke shell\n");
28             else                /* Shell successfully executed command */
29                 printWaitStatus(NULL, status);
30         }
31     }
32
33     exit(EXIT_SUCCESS);
34 }
