/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 35-2 */

 1 #include <sched.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     int j, pol;
 8     struct sched_param sp;
 9
10     if (argc < 3 || strchr("rfobi", argv[1][0]) == NULL)
11         usageErr("%s policy priority [pid...]\n"
12                 "    policy is 'r' (RR), 'f' (FIFO), "
13 #ifdef SCHED_BATCH              /* Linux-specific */
14                 "'b' (BATCH), "
15 #endif
16 #ifdef SCHED_IDLE               /* Linux-specific */
17                 "'i' (IDLE), "
18 #endif
19                 "or 'o' (OTHER)\n",
20                 argv[0]);
21
22     pol = (argv[1][0] == 'r') ? SCHED_RR :
23                 (argv[1][0] == 'f') ? SCHED_FIFO :
24 #ifdef SCHED_BATCH
25                 (argv[1][0] == 'b') ? SCHED_BATCH :
26 #endif
27 #ifdef SCHED_IDLE
28                 (argv[1][0] == 'i') ? SCHED_IDLE :
29 #endif
30                 SCHED_OTHER;
31
32     sp.sched_priority = getInt(argv[2], 0, "priority");
33
34     for (j = 3; j < argc; j++)
35         if (sched_setscheduler(getLong(argv[j], 0, "pid"), pol, &sp) == -1)
36             errExit("sched_setscheduler");
37
38     exit(EXIT_SUCCESS);
39 }
