/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 35 */

 1 #define _GNU_SOURCE
 2 #include <sched.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     pid_t pid;
 9     cpu_set_t set;
10     size_t s;
11     int cpu;
12
13     if (argc != 2 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s pid\n", argv[0]);
15
16     pid = getInt(argv[1], GN_NONNEG, "pid");
17
18     s = sched_getaffinity(pid, sizeof(cpu_set_t), &set);
19     if (s == -1)
20         errExit("sched_getaffinity");
21
22     printf("CPUs:");
23     for (cpu = 0; cpu < CPU_SETSIZE; cpu++)
24         if (CPU_ISSET(cpu, &set))
25             printf(" %d", cpu);
26     printf("\n");
27
28     exit(EXIT_SUCCESS);
29 }
