/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 35-1 */

 1 #include <sys/time.h>
 2 #include <sys/resource.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int which, prio;
 9     id_t who;
10
11     if (argc != 4 || strchr("pgu", argv[1][0]) == NULL)
12         usageErr("%s {p|g|u} who priority\n"
13                 "    set priority of: p=process; g=process group; "
14                 "u=processes for user\n", argv[0]);
15
16     /* Set nice value according to command-line arguments */
17
18     which = (argv[1][0] == 'p') ? PRIO_PROCESS :
19                 (argv[1][0] == 'g') ? PRIO_PGRP : PRIO_USER;
20     who = getLong(argv[2], 0, "who");
21     prio = getInt(argv[3], 0, "prio");
22
23     if (setpriority(which, who, prio) == -1)
24         errExit("setpriority");
25
26     /* Retrieve nice value to check the change */
27
28     errno = 0;                  /* Because successful call may return -1 */
29     prio = getpriority(which, who);
30     if (prio == -1 && errno != 0)
31         errExit("getpriority");
32
33     printf("Nice value = %d\n", prio);
34
35     exit(EXIT_SUCCESS);
36 }
