 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10
11 /* Listing 36-2 */
12
13  1 #include <sys/resource.h>
14  2 #include "print_rlimit.h"       /* Declares function defined here */
15  3 #include "tlpi_hdr.h"
16  4
17  5 int                     /* Print 'msg' followed by limits for 'resource' */
18  6 printRlimit(const char *msg, int resource)
19  7 {
20  8     struct rlimit rlim;
21  9
22 10     if (getrlimit(resource, &rlim) == -1)
23 11         return -1;
24 12
25 13     printf("%s soft=", msg);
26 14     if (rlim.rlim_cur == RLIM_INFINITY)
27 15         printf("infinite");
28 16 #ifdef RLIM_SAVED_CUR           /* Not defined on some implementations */
29 17     else if (rlim.rlim_cur == RLIM_SAVED_CUR)
30 18         printf("unrepresentable");
31 19 #endif
32 20     else
33 21         printf("%lld", (long long) rlim.rlim_cur);
34 22
35 23     printf("; hard=");
36 24     if (rlim.rlim_max == RLIM_INFINITY)
37 25         printf("infinite\n");
38 26 #ifdef RLIM_SAVED_MAX           /* Not defined on some implementations */
39 27     else if (rlim.rlim_max == RLIM_SAVED_MAX)
40 28         printf("unrepresentable");
41 29 #endif
42 30     else
43 31         printf("%lld\n", (long long) rlim.rlim_max);
44 32
45 33     return 0;
46 34 }
