/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 36-2:a */

 1 #include <sys/resource.h>
 2 #include <sys/wait.h>
 3 #include "print_rusage.h"
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     pid_t childPid;
10     struct rusage ru;
11
12     if (argc < 2 || strcmp(argv[1], "--help") == 0)
13         usageErr("%s command arg...\n", argv[0]);
14
15     switch (childPid = fork()) {
16     case -1:
17         errExit("fork");
18
19     case 0:
20         execvp(argv[1], &argv[1]);
21         errExit("execvp");
22
23     default:
24         printf("Command PID: %ld\n", (long) childPid);
25         if (wait(NULL) == -1)
26             errExit("wait");
27         if (getrusage(RUSAGE_CHILDREN, &ru) == -1)
28             errExit("getrusage");
29
30         printf("\n");
31         printRusage("\t", &ru);
32         exit(EXIT_SUCCESS);
33     }
34 }
