/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 3 */

 1 #include "tlpi_hdr.h"
 2
 3 #ifdef NOSYSCALL
 4 static int myfunc() { return 1; }
 5 #endif
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     int numCalls, j, s;
11
12     numCalls = (argc > 1) ? getInt(argv[1], GN_GT_0, "num-calls") : 10000000;
13
14 #ifdef NOSYSCALL
15         printf("Calling normal function\n");
16 #else
17         printf("Calling getppid()\n");
18 #endif
19
20     for (j = 0; j < numCalls; j++)
21 #ifdef NOSYSCALL
22         s = myfunc();
23 #else
24         s = getppid();
25 #endif
26
27     exit(EXIT_SUCCESS);
28 }
