/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 53-2 */

 1 #define _POSIX_C_SOURCE 199309
 2 #include <semaphore.h>
 3 #include <time.h>
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     sem_t *sem;
10     struct timespec ts;
11
12     if (argc != 3 || strcmp(argv[1], "--help") == 0)
13         usageErr("%s sem-name nsecs\n", argv[0]);
14
15     sem = sem_open(argv[1], 0);
16     if (sem == SEM_FAILED)
17         errExit("sem_open");
18
19     if (clock_gettime(CLOCK_REALTIME, &ts) == -1)
20         errExit("clock_gettime-CLOCK_REALTIME");
21
22     ts.tv_sec += atoi(argv[2]);
23
24     if (sem_timedwait(sem, &ts) == -1)
25         errExit("sem_timedwait");
26
27     printf("%ld sem_wait() succeeded\n", (long) getpid());
28     exit(EXIT_SUCCESS);
29 }
