/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 54-3 */

 1 #include <fcntl.h>
 2 #include <sys/mman.h>
 3 #include <sys/stat.h>
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     int fd;
10     char *addr;
11     struct stat sb;
12
13     if (argc != 2 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s shm-name\n", argv[0]);
15
16     fd = shm_open(argv[1], O_RDONLY, 0);    /* Open existing object */
17     if (fd == -1)
18         errExit("shm_open");
19
20     /* Use shared memory object size as length argument for mmap()
21        and as number of bytes to write() */
22
23     if (fstat(fd, &sb) == -1)
24         errExit("fstat");
25
26     addr = mmap(NULL, sb.st_size, PROT_READ, MAP_SHARED, fd, 0);
27     if (addr == MAP_FAILED)
28         errExit("mmap");
29
30     if (close(fd) == -1)                    /* 'fd' is no longer needed */
31         errExit("close");
32
33     write(STDOUT_FILENO, addr, sb.st_size);
34     printf("\n");
35     exit(EXIT_SUCCESS);
36 }
