/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 54-2 */

 1 #include <fcntl.h>
 2 #include <sys/mman.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int fd;
 9     size_t len;                 /* Size of shared memory object */
10     char *addr;
11
12     if (argc != 3 || strcmp(argv[1], "--help") == 0)
13         usageErr("%s shm-name string\n", argv[0]);
14
15     fd = shm_open(argv[1], O_RDWR, 0);      /* Open existing object */
16     if (fd == -1)
17         errExit("shm_open");
18
19     len = strlen(argv[2]);
20     if (ftruncate(fd, len) == -1)           /* Resize object to hold string */
21         errExit("ftruncate");
22     printf("Resized to %ld bytes\n", (long) len);
23
24     addr = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
25     if (addr == MAP_FAILED)
26         errExit("mmap");
27
28     if (close(fd) == -1)                    /* 'fd' is no longer needed */
29         errExit("close");
30
31     printf("copying %ld bytes\n", (long) len);
32     memcpy(addr, argv[2], len);             /* Copy string to shared memory */
33     exit(EXIT_SUCCESS);
34 }
