/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 20-2 */

 1 #include <signal.h>
 2 #include "tlpi_hdr.h"
 3
 4 static void
 5 sigHandler(int sig)
 6 {
 7     static int count = 0;
 8
 9     /* UNSAFE: This handler uses non-async-signal-safe functions
10        (printf(), exit(); see Section 21.1.2) */
11
12     if (sig == SIGINT) {
13         count++;
14         printf("Caught SIGINT (%d)\n", count);
15         return;                 /* Resume execution at point of interruption */
16     }
17
18     /* Must be SIGQUIT - print a message and terminate the process */
19
20     printf("Caught SIGQUIT - that's all folks!\n");
21     exit(EXIT_SUCCESS);
22 }
23
24 int
25 main(int argc, char *argv[])
26 {
27     /* Establish same handler for SIGINT and SIGQUIT */
28
29     if (signal(SIGINT, sigHandler) == SIG_ERR)
30         errExit("signal");
31     if (signal(SIGQUIT, sigHandler) == SIG_ERR)
32         errExit("signal");
33
34     for (;;)                    /* Loop forever, waiting for signals */
35         pause();                /* Block until a signal is caught */
36 }
