/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 20-6 */

 1 #include <signal.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     int numSigs, sig, j;
 8     pid_t pid;
 9
10     if (argc < 4 || strcmp(argv[1], "--help") == 0)
11         usageErr("%s pid num-sigs sig-num [sig-num-2]\n", argv[0]);
12
13     pid = getLong(argv[1], 0, "PID");
14     numSigs = getInt(argv[2], GN_GT_0, "num-sigs");
15     sig = getInt(argv[3], 0, "sig-num");
16
17     /* Send signals to receiver */
18
19     printf("%s: sending signal %d to process %ld %d times\n",
20             argv[0], sig, (long) pid, numSigs);
21
22     for (j = 0; j < numSigs; j++)
23         if (kill(pid, sig) == -1)
24             errExit("kill");
25
26     /* If a fourth command-line argument was specified, send that signal */
27
28     if (argc > 4)
29         if (kill(pid, getInt(argv[4], 0, "sig-num-2")) == -1)
30             errExit("kill");
31
32     printf("%s: exiting\n", argv[0]);
33     exit(EXIT_SUCCESS);
34 }
