/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 20-3 */

 1 #include <signal.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     int s, sig;
 8
 9     if (argc != 3 || strcmp(argv[1], "--help") == 0)
10         usageErr("%s pid sig-num\n", argv[0]);
11
12     sig = getInt(argv[2], 0, "sig-num");
13
14     s = kill(getLong(argv[1], 0, "pid"), sig);
15
16     if (sig != 0) {
17         if (s == -1)
18             errExit("kill");
19
20     } else {                    /* Null signal: process existence check */
21         if (s == 0) {
22             printf("Process exists and we can send it a signal\n");
23         } else {
24             if (errno == EPERM)
25                 printf("Process exists, but we don't have "
26                        "permission to send it a signal\n");
27             else if (errno == ESRCH)
28                 printf("Process does not exist\n");
29             else
30                 errExit("kill");
31         }
32     }
33
34     exit(EXIT_SUCCESS);
35 }
