/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 22-2 */

 1 #define _POSIX_C_SOURCE 199309
 2 #include <signal.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     int sig, numSigs, j, sigData;
 9     union sigval sv;
10
11     if (argc < 4 || strcmp(argv[1], "--help") == 0)
12         usageErr("%s pid sig-num data [num-sigs]\n", argv[0]);
13
14     /* Display our PID and UID, so that they can be compared with the
15        corresponding fields of the siginfo_t argument supplied to the
16        handler in the receiving process */
17
18     printf("%s: PID is %ld, UID is %ld\n", argv[0],
19             (long) getpid(), (long) getuid());
20
21     sig = getInt(argv[2], 0, "sig-num");
22     sigData = getInt(argv[3], GN_ANY_BASE, "data");
23     numSigs = (argc > 4) ? getInt(argv[4], GN_GT_0, "num-sigs") : 1;
24
25     for (j = 0; j < numSigs; j++) {
26         sv.sival_int = sigData + j;
27         if (sigqueue(getLong(argv[1], 0, "pid"), sig, sv) == -1)
28             errExit("sigqueue %d", j);
29     }
30
31     exit(EXIT_SUCCESS);
32 }
