/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 59-4 */

 1 #include "i6d_ucase.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     struct sockaddr_in6 svaddr;
 7     int sfd, j;
 8     size_t msgLen;
 9     ssize_t numBytes;
10     char resp[BUF_SIZE];
11
12     if (argc < 3 || strcmp(argv[1], "--help") == 0)
13         usageErr("%s host-address msg...\n", argv[0]);
14
15     sfd = socket(AF_INET6, SOCK_DGRAM, 0);      /* Create client socket */
16     if (sfd == -1)
17         errExit("socket");
18
19     memset(&svaddr, 0, sizeof(struct sockaddr_in6));
20     svaddr.sin6_family = AF_INET6;
21     svaddr.sin6_port = htons(PORT_NUM);
22     if (inet_pton(AF_INET6, argv[1], &svaddr.sin6_addr) <= 0)
23         fatal("inet_pton failed for address '%s'", argv[1]);
24
25     /* Send messages to server; echo responses on stdout */
26
27     for (j = 2; j < argc; j++) {
28         msgLen = strlen(argv[j]);
29         if (sendto(sfd, argv[j], msgLen, 0, (struct sockaddr *) &svaddr,
30                     sizeof(struct sockaddr_in6)) != msgLen)
31             fatal("sendto");
32
33         numBytes = recvfrom(sfd, resp, BUF_SIZE, 0, NULL, 0);
34         if (numBytes == -1)
35             errExit("recvfrom");
36
37         printf("Response %d: %.*s\n", j - 1, (int) numBytes, resp);
38     }
39
40     exit(EXIT_SUCCESS);
41 }
