/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 59-3 */

 1 #include "i6d_ucase.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     struct sockaddr_in6 svaddr, claddr;
 7     int sfd, j;
 8     ssize_t numBytes;
 9     socklen_t len;
10     char buf[BUF_SIZE];
11     char claddrStr[INET6_ADDRSTRLEN];
12
13     sfd = socket(AF_INET6, SOCK_DGRAM, 0);
14     if (sfd == -1)
15         errExit("socket");
16
17     memset(&svaddr, 0, sizeof(struct sockaddr_in6));
18     svaddr.sin6_family = AF_INET6;
19     svaddr.sin6_addr = in6addr_any;                     /* Wildcard address */
20     svaddr.sin6_port = htons(PORT_NUM);
21
22     if (bind(sfd, (struct sockaddr *) &svaddr,
23                 sizeof(struct sockaddr_in6)) == -1)
24         errExit("bind");
25
26     /* Receive messages, convert to uppercase, and return to client */
27
28     for (;;) {
29         len = sizeof(struct sockaddr_in6);
30         numBytes = recvfrom(sfd, buf, BUF_SIZE, 0,
31                             (struct sockaddr *) &claddr, &len);
32         if (numBytes == -1)
33             errExit("recvfrom");
34
35         if (inet_ntop(AF_INET6, &claddr.sin6_addr, claddrStr,
36                     INET6_ADDRSTRLEN) == NULL)
37             printf("Couldn't convert client address to string\n");
38         else
39             printf("Server received %ld bytes from (%s, %u)\n",
40                     (long) numBytes, claddrStr, ntohs(claddr.sin6_port));
41
42         for (j = 0; j < numBytes; j++)
43             buf[j] = toupper((unsigned char) buf[j]);
44
45         if (sendto(sfd, buf, numBytes, 0, (struct sockaddr *) &claddr, len) !=
46                 numBytes)
47             fatal("sendto");
48     }
49 }
