/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 60-3 */

 1 #include "id_echo.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     int sfd, j;
 7     size_t len;
 8     ssize_t numRead;
 9     char buf[BUF_SIZE];
10
11     if (argc < 2 || strcmp(argv[1], "--help") == 0)
12         usageErr("%s host msg...\n", argv[0]);
13
14     /* Construct server address from first command-line argument */
15
16     sfd = inetConnect(argv[1], SERVICE, SOCK_DGRAM);
17     if (sfd == -1)
18         fatal("Could not connect to server socket");
19
20     /* Send remaining command-line arguments to server as separate datagrams */
21
22     for (j = 2; j < argc; j++) {
23         len = strlen(argv[j]);
24         if (write(sfd, argv[j], len) != len)
25             fatal("partial/failed write");
26
27         numRead = read(sfd, buf, BUF_SIZE);
28         if (numRead == -1)
29             errExit("read");
30
31         printf("[%ld bytes] %.*s\n", (long) numRead, (int) numRead, buf);
32     }
33
34     exit(EXIT_SUCCESS);
35 }
