/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 60-6 */

 1 #include <syslog.h>
 2 #include "tlpi_hdr.h"
 3
 4 #define BUF_SIZE 4096
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     char buf[BUF_SIZE];
10     ssize_t numRead;
11
12     while ((numRead = read(STDIN_FILENO, buf, BUF_SIZE)) > 0) {
13         if (write(STDOUT_FILENO, buf, numRead) != numRead) {
14             syslog(LOG_ERR, "write() failed: %s", strerror(errno));
15             exit(EXIT_FAILURE);
16         }
17     }
18
19     if (numRead == -1) {
20         syslog(LOG_ERR, "Error from read(): %s", strerror(errno));
21         exit(EXIT_FAILURE);
22     }
23
24     exit(EXIT_SUCCESS);
25 }
