/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 59-2:c */

 1 #include "is_seqnum_v2.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     char *reqLenStr;                    /* Requested length of sequence */
 7     char seqNumStr[INT_LEN];            /* Start of granted sequence */
 8     int cfd;
 9     ssize_t numRead;
10
11     if (argc < 2 || strcmp(argv[1], "--help") == 0)
12         usageErr("%s server-host [sequence-len]\n", argv[0]);
13
14     cfd = inetConnect(argv[1], PORT_NUM_STR, SOCK_STREAM);
15     if (cfd == -1)
16         fatal("inetConnect() failed");
17
18     reqLenStr = (argc > 2) ? argv[2] : "1";
19     if (write(cfd, reqLenStr, strlen(reqLenStr)) !=  strlen(reqLenStr))
20         fatal("Partial/failed write (reqLenStr)");
21     if (write(cfd, "\n", 1) != 1)
22         fatal("Partial/failed write (newline)");
23
24     numRead = readLine(cfd, seqNumStr, INT_LEN);
25     if (numRead == -1)
26         errExit("readLine");
27     if (numRead == 0)
28         fatal("Unexpected EOF from server");
29
30     printf("Sequence number: %s", seqNumStr);   /* Includes '\n' */
31
32     exit(EXIT_SUCCESS);                         /* Closes 'cfd' */
33 }
