 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10
11 /* Solution for Exercise 59-1:a */
12
13  1 #include <unistd.h>
14  2 #include <errno.h>
15  3 #include "read_line_buf.h"
16  4
17  5 void                    /* Initialize a ReadLineBuf structure */
18  6 readLineBufInit(int fd, struct ReadLineBuf *rlbuf)
19  7 {
20  8     rlbuf->fd = fd;
21  9     rlbuf->len = 0;
22 10     rlbuf->next = 0;
23 11 }
24 12
25 13 /* Return a line of input from the buffer 'rlbuf', placing the characters in
26 14    'buffer'. The 'n' argument specifies the size of 'buffer'. If the line of
27 15    input is larger than this, then the excess characters are discarded. */
28 16
29 17 ssize_t
30 18 readLineBuf(struct ReadLineBuf *rlbuf, char *buffer, size_t n)
31 19 {
32 20     size_t cnt;
33 21     char c;
34 22
35 23     if (n <= 0 || buffer == NULL) {
36 24         errno = EINVAL;
37 25         return -1;
38 26     }
39 27
40 28     cnt = 0;
41 29
42 30     /* Fetch characters from rlbuf->buf, up to the next new line. */
43 31
44 32     for (;;) {
45 33
46 34         /* If there are insufficient characters in 'tlbuf', then obtain
47 35            further input from the associated file descriptor. */
48 36
49 37         if (rlbuf->next >= rlbuf->len) {
50 38             rlbuf->len = read(rlbuf->fd, rlbuf->buf, RL_MAX_BUF);
51 39             if (rlbuf->len == -1)
52 40                 return -1;
53 41
54 42             if (rlbuf->len == 0)        /* End of file */
55 43                 break;
56 44
57 45             rlbuf->next = 0;
58 46         }
59 47
60 48         c = rlbuf->buf[rlbuf->next];
61 49         rlbuf->next++;
62 50
63 51         if (cnt < n)
64 52             buffer[cnt++] = c;
65 53
66 54         if (c == '\n')
67 55             break;
68 56     }
69 57
70 58     return cnt;
71 59 }
