/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 61-3 */

 1 #include "tlpi_hdr.h"
 2 #define BUF_SIZE 8192
 3
 4 ssize_t
 5 sendfile(int out_fd, int in_fd, off_t *offset, size_t count)
 6 {
 7     off_t orig;
 8     char buf[BUF_SIZE];
 9     size_t toRead, numRead, numSent, totSent;
10
11     if (offset != NULL) {
12
13         /* Save current file offset and set offset to value in '*offset' */
14
15         orig = lseek(in_fd, 0, SEEK_CUR);
16         if (orig == -1)
17             return -1;
18         if (lseek(in_fd, *offset, SEEK_SET) == -1)
19             return -1;
20     }
21
22     totSent = 0;
23
24     while (count > 0) {
25         toRead = min(BUF_SIZE, count);
26
27         numRead = read(in_fd, buf, toRead);
28         if (numRead == -1)
29             return -1;
30         if (numRead == 0)
31             break;                      /* EOF */
32
33         numSent = write(out_fd, buf, numRead);
34         if (numSent == -1)
35             return -1;
36         if (numSent == 0)               /* Should never happen */
37             fatal("sendfile: write() transferred 0 bytes");
38
39         count -= numSent;
40         totSent += numSent;
41     }
42
43     if (offset != NULL) {
44
45         /* Return updated file offset in '*offset', and reset the file offset
46            to the value it had when we were called. */
47
48         *offset = lseek(in_fd, 0, SEEK_CUR);
49         if (*offset == -1)
50             return -1;
51         if (lseek(in_fd, orig, SEEK_SET) == -1)
52             return -1;
53     }
54
55     return totSent;
56 }
