/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 61-3 */

 1 #include "inet_sockets.h"               /* Declares our socket functions */
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     int listenFd, acceptFd, connFd;
 8     socklen_t len;                      /* Size of socket address buffer */
 9     void *addr;                         /* Buffer for socket address */
10     char addrStr[IS_ADDR_STR_LEN];
11
12     if (argc != 2 || strcmp(argv[1], "--help") == 0)
13         usageErr("%s service\n", argv[0]);
14
15     listenFd = inetListen(argv[1], 5, &len);
16     if (listenFd == -1)
17         errExit("inetListen");
18
19     connFd = inetConnect(NULL, argv[1], SOCK_STREAM);
20     if (connFd == -1)
21         errExit("inetConnect");
22
23     acceptFd = accept(listenFd, NULL, 0);
24     if (acceptFd == -1)
25         errExit("accept");
26
27     addr = malloc(len);
28     if (addr == NULL)
29         errExit("malloc");
30
31     if (getsockname(connFd, addr, &len) == -1)
32         errExit("getsockname");
33     printf("getsockname(connFd):   %s\n",
34             inetAddressStr(addr, len, addrStr, IS_ADDR_STR_LEN));
35     if (getsockname(acceptFd, addr, &len) == -1)
36         errExit("getsockname");
37     printf("getsockname(acceptFd): %s\n",
38             inetAddressStr(addr, len, addrStr, IS_ADDR_STR_LEN));
39
40     if (getpeername(connFd, addr, &len) == -1)
41         errExit("getpeername");
42     printf("getpeername(connFd):   %s\n",
43             inetAddressStr(addr, len, addrStr, IS_ADDR_STR_LEN));
44     if (getpeername(acceptFd, addr, &len) == -1)
45         errExit("getpeername");
46     printf("getpeername(acceptFd): %s\n",
47             inetAddressStr(addr, len, addrStr, IS_ADDR_STR_LEN));
48
49     sleep(30);                          /* Give us time to run netstat(8) */
50     exit(EXIT_SUCCESS);
51 }
