/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 57-6 */

 1 #include "ud_ucase.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     struct sockaddr_un svaddr, claddr;
 7     int sfd, j;
 8     ssize_t numBytes;
 9     socklen_t len;
10     char buf[BUF_SIZE];
11
12     sfd = socket(AF_UNIX, SOCK_DGRAM, 0);       /* Create server socket */
13     if (sfd == -1)
14         errExit("socket");
15
16     /* Construct well-known address and bind server socket to it */
17
18     if (remove(SV_SOCK_PATH) == -1 && errno != ENOENT)
19         errExit("remove-%s", SV_SOCK_PATH);
20
21     memset(&svaddr, 0, sizeof(struct sockaddr_un));
22     svaddr.sun_family = AF_UNIX;
23     strncpy(svaddr.sun_path, SV_SOCK_PATH, sizeof(svaddr.sun_path) - 1);
24
25     if (bind(sfd, (struct sockaddr *) &svaddr, sizeof(struct sockaddr_un)) == -1)
26         errExit("bind");
27
28     /* Receive messages, convert to uppercase, and return to client */
29
30     for (;;) {
31         len = sizeof(struct sockaddr_un);
32         numBytes = recvfrom(sfd, buf, BUF_SIZE, 0,
33                             (struct sockaddr *) &claddr, &len);
34         if (numBytes == -1)
35             errExit("recvfrom");
36
37         printf("Server received %ld bytes from %s\n", (long) numBytes,
38                 claddr.sun_path);
39
40         for (j = 0; j < numBytes; j++)
41             buf[j] = toupper((unsigned char) buf[j]);
42
43         if (sendto(sfd, buf, numBytes, 0, (struct sockaddr *) &claddr, len) !=
44                 numBytes)
45             fatal("sendto");
46     }
47 }
