/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 57-4 */

 1 #include "us_xfr.h"
 2
 3 int
 4 main(int argc, char *argv[])
 5 {
 6     struct sockaddr_un addr;
 7     int sfd;
 8     ssize_t numRead;
 9     char buf[BUF_SIZE];
10
11     sfd = socket(AF_UNIX, SOCK_STREAM, 0);      /* Create client socket */
12     if (sfd == -1)
13         errExit("socket");
14
15     /* Construct server address, and make the connection */
16
17     memset(&addr, 0, sizeof(struct sockaddr_un));
18     addr.sun_family = AF_UNIX;
19     strncpy(addr.sun_path, SV_SOCK_PATH, sizeof(addr.sun_path) - 1);
20
21     if (connect(sfd, (struct sockaddr *) &addr,
22                 sizeof(struct sockaddr_un)) == -1)
23         errExit("connect");
24
25     /* Copy stdin to socket */
26
27     while ((numRead = read(STDIN_FILENO, buf, BUF_SIZE)) > 0)
28         if (write(sfd, buf, numRead) != numRead)
29             fatal("partial/failed write");
30
31     if (numRead == -1)
32         errExit("read");
33
34     exit(EXIT_SUCCESS);         /* Closes our socket; server sees EOF */
35 }
