/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 57-3 */

 1 #include "us_xfr.h"
 2
 3 #define BACKLOG 5
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     struct sockaddr_un addr;
 9     int sfd, cfd;
10     ssize_t numRead;
11     char buf[BUF_SIZE];
12
13     sfd = socket(AF_UNIX, SOCK_STREAM, 0);
14     if (sfd == -1)
15         errExit("socket");
16
17     /* Construct server socket address, bind socket to it,
18        and make this a listening socket */
19
20     if (remove(SV_SOCK_PATH) == -1 && errno != ENOENT)
21         errExit("remove-%s", SV_SOCK_PATH);
22
23     memset(&addr, 0, sizeof(struct sockaddr_un));
24     addr.sun_family = AF_UNIX;
25     strncpy(addr.sun_path, SV_SOCK_PATH, sizeof(addr.sun_path) - 1);
26
27     if (bind(sfd, (struct sockaddr *) &addr, sizeof(struct sockaddr_un)) == -1)
28         errExit("bind");
29
30     if (listen(sfd, BACKLOG) == -1)
31         errExit("listen");
32
33     for (;;) {          /* Handle client connections iteratively */
34
35         /* Accept a connection. The connection is returned on a new
36            socket, 'cfd'; the listening socket ('sfd') remains open
37            and can be used to accept further connections. */
38
39         cfd = accept(sfd, NULL, 0);
40         if (cfd == -1)
41             errExit("accept");
42
43         /* Transfer data from connected socket to stdout until EOF */
44
45         while ((numRead = read(cfd, buf, BUF_SIZE)) > 0)
46             if (write(STDOUT_FILENO, buf, numRead) != numRead)
47                 fatal("partial/failed write");
48
49         if (numRead == -1)
50             errExit("read");
51
52         if (close(cfd) == -1)
53             errMsg("close");
54     }
55 }
