/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 46-6 */

 1 #define _GNU_SOURCE
 2 #include <sys/types.h>
 3 #include <sys/msg.h>
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     int maxind, ind, msqid;
10     struct msqid_ds ds;
11     struct msginfo msginfo;
12
13     /* Obtain size of kernel 'entries' array */
14
15     maxind = msgctl(0, MSG_INFO, (struct msqid_ds *) &msginfo);
16     if (maxind == -1)
17         errExit("msgctl-MSG_INFO");
18
19     printf("maxind: %d\n\n", maxind);
20     printf("index     id       key      messages\n");
21
22     /* Retrieve and display information from each element of 'entries' array */
23
24     for (ind = 0; ind <= maxind; ind++) {
25         msqid = msgctl(ind, MSG_STAT, &ds);
26         if (msqid == -1) {
27             if (errno != EINVAL && errno != EACCES)
28                 errMsg("msgctl-MSG_STAT");              /* Unexpected error */
29             continue;                                   /* Ignore this item */
30         }
31
32         printf("%4d %8d  0x%08lx %7ld\n", ind, msqid,
33                 (unsigned long) ds.msg_perm.__key, (long) ds.msg_qnum);
34     }
35
36     exit(EXIT_SUCCESS);
37 }
