 1 /*************************************************************************\
 2 *                  Copyright (C) Michael Kerrisk, 2014.                   *
 3 *                                                                         *
 4 * This program is free software. You may use, modify, and redistribute it *
 5 * under the terms of the GNU Lesser General Public License as published   *
 6 * by the Free Software Foundation, either version 3 or (at your option)   *
 7 * any later version. This program is distributed without any warranty.    *
 8 * See the files COPYING.lgpl-v3 and COPYING.gpl-v3 for details.           *
 9 \*************************************************************************/
10
11 /* Solution for Exercise 47-5:a */
12
13  1 #include <sys/types.h>
14  2 #include <sys/sem.h>
15  3 #include "semun.h"              /* Definition of semun union */
16  4 #include "event_flags.h"
17  5 #include "tlpi_hdr.h"
18  6
19  7 /* Wait for the specified flag to become "set" (0) */
20  8
21  9 int
22 10 waitForEventFlag(int semId, int semNum)
23 11 {
24 12     struct sembuf sops;
25 13
26 14     sops.sem_num = semNum;
27 15     sops.sem_op = 0;                    /* Wait for semaphore to equal 0 */
28 16     sops.sem_flg = 0;
29 17
30 18     /* Waiting for a semaphore to become zero may block, so we
31 19        program to retry if interrupted by a signal handler */
32 20
33 21     while (semop(semId, &sops, 1) == -1)
34 22         if (errno != EINTR)
35 23             return -1;
36 24     return 0;
37 25 }
38 26
39 27 /* "Clear" the event flag (give it the value 1) */
40 28
41 29 int
42 30 clearEventFlag(int semId, int semNum)
43 31 {
44 32     union semun arg;
45 33
46 34     arg.val = 1;
47 35     return semctl(semId, semNum, SETVAL, arg);
48 36 }
49 37
50 38 /* "Set" the event flag (give it the value 0) */
51 39
52 40 int
53 41 setEventFlag(int semId, int semNum)
54 42 {
55 43     union semun arg;
56 44
57 45     arg.val = 0;
58 46     return semctl(semId, semNum, SETVAL, arg);
59 47 }
60 48
61 49 /* Get current state of event flag */
62 50
63 51 int
64 52 getFlagState(int semId, int semNum, Boolean *isSet)
65 53 {
66 54     int sem_val;
67 55     union semun dummy;
68 56
69 57     sem_val = semctl(semId, semNum, GETVAL, dummy);
70 58     if (sem_val == -1)
71 59         return -1;
72 60
73 61     *isSet = (sem_val == 0) ? TRUE : FALSE;
74 62     return 0;
75 63 }
