/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 47-5 */

 1 #include <sys/types.h>
 2 #include <sys/sem.h>
 3 #include <sys/stat.h>
 4 #include "semun.h"                      /* Definition of semun union */
 5 #include "tlpi_hdr.h"
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     int semid, key, perms;
11     struct sembuf sops[2];
12
13     key = 12345;
14     perms = S_IRUSR | S_IWUSR;
15     semid = semget(key, 1, IPC_CREAT | IPC_EXCL | perms);
16
17     if (semid != -1) {                  /* Successfully created the semaphore */
18         union semun arg;
19
20         /* XXXX */
21
22         arg.val = 0;                    /* So initialize it */
23         if (semctl(semid, 0, SETVAL, arg) == -1)
24             errExit("semctl");
25
26     } else {                            /* We didn't create semaphore set */
27         if (errno != EEXIST) {          /* Unexpected error from semget() */
28             errExit("semget 1");
29         } else {                        /* Someone else already created it */
30             semid = semget(key, 1, perms);      /* So just get ID */
31             if (semid == -1)
32                 errExit("semget 2");
33         }
34     }
35
36     /* Now perform some operation on the semaphore */
37
38     sops[0].sem_op = 1;         /* Add 1 */
39     sops[0].sem_num = 0;        /* ... to semaphore 0 */
40     sops[0].sem_flg = 0;
41     if (semop(semid, sops, 1) == -1)
42         errExit("semop");
43
44     exit(EXIT_SUCCESS);
45 }
