/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 47-3 */

 1 #include <sys/types.h>
 2 #include <sys/sem.h>
 3 #include <time.h>
 4 #include "semun.h"                      /* Definition of semun union */
 5 #include "tlpi_hdr.h"
 6
 7 int
 8 main(int argc, char *argv[])
 9 {
10     struct semid_ds ds;
11     union semun arg, dummy;             /* Fourth argument for semctl() */
12     int semid, j;
13
14     if (argc != 2 || strcmp(argv[1], "--help") == 0)
15         usageErr("%s semid\n", argv[0]);
16
17     semid = getInt(argv[1], 0, "semid");
18
19     arg.buf = &ds;
20     if (semctl(semid, 0, IPC_STAT, arg) == -1)
21         errExit("semctl");
22
23     printf("Semaphore changed: %s", ctime(&ds.sem_ctime));
24     printf("Last semop():      %s", ctime(&ds.sem_otime));
25
26     /* Display per-semaphore information */
27
28     arg.array = calloc(ds.sem_nsems, sizeof(arg.array[0]));
29     if (arg.array == NULL)
30         errExit("calloc");
31     if (semctl(semid, 0, GETALL, arg) == -1)
32         errExit("semctl-GETALL");
33
34     printf("Sem #  Value  SEMPID  SEMNCNT  SEMZCNT\n");
35
36     for (j = 0; j < ds.sem_nsems; j++)
37         printf("%3d   %5d   %5d  %5d    %5d\n", j, arg.array[j],
38                 semctl(semid, j, GETPID, dummy),
39                 semctl(semid, j, GETNCNT, dummy),
40                 semctl(semid, j, GETZCNT, dummy));
41
42     exit(EXIT_SUCCESS);
43 }
