/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 47-4 */

 1 #include <sys/types.h>
 2 #include <sys/sem.h>
 3 #include "semun.h"                      /* Definition of semun union */
 4 #include "tlpi_hdr.h"
 5
 6 int
 7 main(int argc, char *argv[])
 8 {
 9     struct semid_ds ds;
10     union semun arg;                    /* Fourth argument for semctl() */
11     int j, semid;
12
13     if (argc < 3 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s semid val...\n", argv[0]);
15
16     semid = getInt(argv[1], 0, "semid");
17
18     /* Obtain size of semaphore set */
19
20     arg.buf = &ds;
21     if (semctl(semid, 0, IPC_STAT, arg) == -1)
22         errExit("semctl");
23
24     if (ds.sem_nsems != argc - 2)
25         cmdLineErr("Set contains %ld semaphores, but %d values were supplied\n",
26                 (long) ds.sem_nsems, argc - 2);
27
28     /* Set up array of values; perform semaphore initialization */
29
30     arg.array = calloc(ds.sem_nsems, sizeof(arg.array[0]));
31     if (arg.array == NULL)
32         errExit("calloc");
33
34     for (j = 2; j < argc; j++)
35         arg.array[j - 2] = getInt(argv[j], 0, "val");
36
37     if (semctl(semid, 0, SETALL, arg) == -1)
38         errExit("semctl-SETALL");
39     printf("Semaphore values changed (PID=%ld)\n", (long) getpid());
40
41     exit(EXIT_SUCCESS);
42 }
