/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 48 */

 1 #include <sys/types.h>
 2 #include <sys/shm.h>
 3 #include "tlpi_hdr.h"
 4
 5 static void
 6 usageError(char *progName)
 7 {
 8     fprintf(stderr, "Usage: %s [shmid:address[rR]]...\n", progName);
 9     fprintf(stderr, "            r=SHM_RND; R=SHM_RDONLY\n");
10     exit(EXIT_FAILURE);
11 }
12
13 int
14 main(int argc, char *argv[])
15 {
16     void *addr;
17     char *retAddr, *p;
18     int j, flags, shmid;
19
20     printf("SHMLBA = %ld (%#lx), PID = %ld\n",
21             (long) SHMLBA, (unsigned long) SHMLBA, (long) getpid());
22
23     for (j = 1; j < argc; j++) {
24         shmid = strtol(argv[j], &p, 0);
25         if (*p != ':')
26             usageError(argv[0]);
27
28         addr = (void *) strtol(p + 1, NULL, 0);
29         flags = (strchr(p + 1, 'r') != NULL) ? SHM_RND : 0;
30         if (strchr(p + 1, 'R') != NULL)
31             flags |= SHM_RDONLY;
32
33         retAddr = shmat(shmid, addr, flags);
34         if (retAddr == (void *) -1)
35             errExit("shmat: %s", argv[j]);
36
37         printf("%d: %s ==> %p\n", j, argv[j], retAddr);
38     }
39
40     printf("Sleeping 5 seconds\n");
41     sleep(5);
42
43     exit(EXIT_SUCCESS);
44 }
