/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 48 */

 1 #define _GNU_SOURCE
 2 #include <sys/shm.h>
 3 #include "tlpi_hdr.h"
 4
 5 int
 6 main(int argc, char *argv[])
 7 {
 8     struct shm_info info;
 9     int s;
10
11     s = shmctl(0, SHM_INFO, (struct shmid_ds *) &info);
12     if (s == -1)
13         errExit("shmctl");
14
15     printf("Maximum ID index = %d\n", s);
16     printf("shm_tot          = %ld\n", (long) info.shm_tot);
17     printf("shm_rss          = %ld\n", (long) info.shm_rss);
18     printf("shm_swp          = %ld\n", (long) info.shm_swp);
19     printf("swap_attempts    = %ld\n", (long) info.swap_attempts);
20     printf("swap_successes   = %ld\n", (long) info.swap_successes);
21
22     exit(EXIT_SUCCESS);
23 }
