/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 48-1 */

 1 #include <sys/types.h>
 2 #include <sys/stat.h>
 3 #include <sys/sem.h>
 4 #include <sys/shm.h>
 5 #include "binary_sems.h"        /* Declares our binary semaphore functions */
 6 #include "tlpi_hdr.h"
 7 
 8 #define SHM_KEY 0x1234          /* Key for shared memory segment */
 9 #define SEM_KEY 0x5678          /* Key for semaphore set */
10 
11 #define OBJ_PERMS (S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP)
12                                 /* Permissions for our IPC objects */
13 
14 #define WRITE_SEM 0             /* Writer has access to shared memory */
15 #define READ_SEM 1              /* Reader has access to shared memory */
16 
17 #ifndef BUF_SIZE                /* Allow "cc -D" to override definition */
18 #define BUF_SIZE 1024           /* Size of transfer buffer */
19 #endif
20 
21 struct shmseg {                 /* Defines structure of shared memory segment */
22     int cnt;                    /* Number of bytes used in 'buf' */
23     char buf[BUF_SIZE];         /* Data being transferred */
24 };
