/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 11-2 */

 1 #include "tlpi_hdr.h"
 2
 3 static void             /* Print 'msg' plus value of fpathconf(fd, name) */
 4 fpathconfPrint(const char *msg, int fd, int name)
 5 {
 6     long lim;
 7
 8     errno = 0;
 9     lim = fpathconf(fd, name);
10     if (lim != -1) {        /* Call succeeded, limit determinate */
11         printf("%s %ld\n", msg, lim);
12     } else {
13         if (errno == 0)     /* Call succeeded, limit indeterminate */
14             printf("%s (indeterminate)\n", msg);
15         else                /* Call failed */
16             errExit("fpathconf %s", msg);
17     }
18 }
19
20 int
21 main(int argc, char *argv[])
22 {
23     fpathconfPrint("_PC_NAME_MAX: ", STDIN_FILENO, _PC_NAME_MAX);
24     fpathconfPrint("_PC_PATH_MAX: ", STDIN_FILENO, _PC_PATH_MAX);
25     fpathconfPrint("_PC_PIPE_BUF: ", STDIN_FILENO, _PC_PIPE_BUF);
26     exit(EXIT_SUCCESS);
27 }
