/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 11-1 */

 1 #include "tlpi_hdr.h"
 2
 3 static void             /* Print 'msg' plus sysconf() value for 'name' */
 4 sysconfPrint(const char *msg, int name)
 5 {
 6     long lim;
 7
 8     errno = 0;
 9     lim = sysconf(name);
10     if (lim != -1) {        /* Call succeeded, limit determinate */
11         printf("%s %ld\n", msg, lim);
12     } else {
13         if (errno == 0)     /* Call succeeded, limit indeterminate */
14             printf("%s (indeterminate)\n", msg);
15         else                /* Call failed */
16             errExit("sysconf %s", msg);
17     }
18 }
19
20 int
21 main(int argc, char *argv[])
22 {
23     sysconfPrint("_SC_ARG_MAX:        ", _SC_ARG_MAX);
24     sysconfPrint("_SC_LOGIN_NAME_MAX: ", _SC_LOGIN_NAME_MAX);
25     sysconfPrint("_SC_OPEN_MAX:       ", _SC_OPEN_MAX);
26     sysconfPrint("_SC_NGROUPS_MAX:    ", _SC_NGROUPS_MAX);
27     sysconfPrint("_SC_PAGESIZE:       ", _SC_PAGESIZE);
28     sysconfPrint("_SC_RTSIG_MAX:      ", _SC_RTSIG_MAX);
29     exit(EXIT_SUCCESS);
30 }
