/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 31-4 */

 1 #define _GNU_SOURCE                 /* Get '_sys_nerr' and '_sys_errlist'
 2                                        declarations from <stdio.h> */
 3 #include <stdio.h>
 4 #include <string.h>                 /* Get declaration of strerror() */
 5 #include <pthread.h>
 6
 7 #define MAX_ERROR_LEN 256           /* Maximum length of string in per-thread
 8                                        buffer returned by strerror() */
 9
10 static __thread char buf[MAX_ERROR_LEN];
11                                     /* Thread-local return buffer */
12
13 char *
14 strerror(int err)
15 {
16     if (err < 0 || err >= _sys_nerr || _sys_errlist[err] == NULL) {
17         snprintf(buf, MAX_ERROR_LEN, "Unknown error %d", err);
18     } else {
19         strncpy(buf, _sys_errlist[err], MAX_ERROR_LEN - 1);
20         buf[MAX_ERROR_LEN - 1] = '\0';          /* Ensure null termination */
21     }
22
23     return buf;
24 }
