/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 10-1 */

 1 #include <locale.h>
 2 #include <time.h>
 3 #include <sys/time.h>
 4 #include "tlpi_hdr.h"
 5
 6 #define SECONDS_IN_TROPICAL_YEAR (365.24219 * 24 * 60 * 60)
 7
 8 int
 9 main(int argc, char *argv[])
10 {
11     time_t t;
12     struct tm *gmp, *locp;
13     struct tm gm, loc;
14     struct timeval tv;
15
16     t = time(NULL);
17     printf("Seconds since the Epoch (1 Jan 1970): %ld", (long) t);
18     printf(" (about %6.3f years)\n", t / SECONDS_IN_TROPICAL_YEAR);
19
20     if (gettimeofday(&tv, NULL) == -1)
21         errExit("gettimeofday");
22     printf("  gettimeofday() returned %ld secs, %ld microsecs\n",
23             (long) tv.tv_sec, (long) tv.tv_usec);
24
25     gmp = gmtime(&t);
26     if (gmp == NULL)
27         errExit("gmtime");
28
29     gm = *gmp;          /* Save local copy, since *gmp may be modified
30                            by asctime() or gmtime() */
31     printf("Broken down by gmtime():\n");
32     printf("  year=%d mon=%d mday=%d hour=%d min=%d sec=%d ", gm.tm_year,
33             gm.tm_mon, gm.tm_mday, gm.tm_hour, gm.tm_min, gm.tm_sec);
34     printf("wday=%d yday=%d isdst=%d\n", gm.tm_wday, gm.tm_yday, gm.tm_isdst);
35
36     locp = localtime(&t);
37     if (locp == NULL)
38         errExit("localtime");
39
40     loc = *locp;        /* Save local copy */
41
42     printf("Broken down by localtime():\n");
43     printf("  year=%d mon=%d mday=%d hour=%d min=%d sec=%d ",
44             loc.tm_year, loc.tm_mon, loc.tm_mday,
45             loc.tm_hour, loc.tm_min, loc.tm_sec);
46     printf("wday=%d yday=%d isdst=%d\n\n",
47             loc.tm_wday, loc.tm_yday, loc.tm_isdst);
48
49     printf("asctime() formats the gmtime() value as: %s", asctime(&gm));
50     printf("ctime() formats the time() value as:     %s", ctime(&t));
51
52     printf("mktime() of gmtime() value:    %ld secs\n", (long) mktime(&gm));
53     printf("mktime() of localtime() value: %ld secs\n", (long) mktime(&loc));
54
55     exit(EXIT_SUCCESS);
56 }
