/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 23-3 */

 1 #define _POSIX_C_SOURCE 199309
 2 #include <signal.h>
 3 #include <time.h>
 4 #include "curr_time.h"          /* Declaration of currTime() */
 5 #include "tlpi_hdr.h"
 6
 7 static void
 8 handler(int sig, siginfo_t *si, void *uc)
 9 {
10     printf("[%s] Got signal %d\n", currTime("%T"), sig);
11     printf("    sival_int          = %d\n", si->si_value.sival_int);
12     printf("    timer_getoverrun() = %d\n",
13             timer_getoverrun((timer_t) si->si_value.sival_ptr));
14 }
15
16 int
17 main(int argc, char *argv[])
18 {
19     struct itimerspec ts;
20     timer_t tid;
21     int j;
22     struct sigaction sa;
23
24     if (argc < 2)
25         usageErr("%s secs [nsecs [int-secs [int-nsecs]]]\n", argv[0]);
26
27     sa.sa_flags = SA_SIGINFO;
28     sa.sa_sigaction = handler;
29     sigemptyset(&sa.sa_mask);
30     if (sigaction(SIGALRM, &sa, NULL) == -1)
31         errExit("sigaction");
32
33     if (timer_create(CLOCK_REALTIME, NULL, &tid) == -1)
34         errExit("timer_create");
35     printf("timer ID = %ld\n", (long) tid);
36
37     ts.it_value.tv_sec = atoi(argv[1]);
38     ts.it_value.tv_nsec = (argc > 2) ? atoi(argv[2]) : 0;
39     ts.it_interval.tv_sec = (argc > 3) ? atoi(argv[3]) : 0;
40     ts.it_interval.tv_nsec = (argc > 4) ? atoi(argv[4]) : 0;
41     if (timer_settime(tid, 0, &ts, NULL) == -1)
42         errExit("timer_settime");
43
44     for (j = 0; ; j++)
45         pause();
46 }
