/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 62-5 */

 1 #include <signal.h>
 2 #include <termios.h>
 3 #include <sys/ioctl.h>
 4 #include "tlpi_hdr.h"
 5
 6 static void
 7 sigwinchHandler(int sig)
 8 {
 9 }
10
11 int
12 main(int argc, char *argv[])
13 {
14     struct winsize ws;
15     struct sigaction sa;
16
17     sigemptyset(&sa.sa_mask);
18     sa.sa_flags = 0;
19     sa.sa_handler = sigwinchHandler;
20     if (sigaction(SIGWINCH, &sa, NULL) == -1)
21         errExit("sigaction");
22
23     for (;;) {
24         pause();                        /* Wait for SIGWINCH signal */
25
26         if (ioctl(STDIN_FILENO, TIOCGWINSZ, &ws) == -1)
27             errExit("ioctl");
28         printf("Caught SIGWINCH, new window size: "
29                 "%d rows * %d columns\n", ws.ws_row, ws.ws_col);
30     }
31 }
