/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Supplementary program for Chapter 8 */

 1 #include <pwd.h>
 2 #include "tlpi_hdr.h"
 3
 4 int
 5 main(int argc, char *argv[])
 6 {
 7     struct passwd pwd;
 8     struct passwd *result;
 9     char *buf;
10     size_t bufSize;
11     int s;
12
13     if (argc != 2 || strcmp(argv[1], "--help") == 0)
14         usageErr("%s username\n", argv[0]);
15
16     bufSize = sysconf(_SC_GETPW_R_SIZE_MAX);
17     buf = malloc(bufSize);
18     if (buf == NULL)
19         errExit("malloc %d", bufSize);
20
21     s = getpwnam_r(argv[1], &pwd, buf, bufSize, &result);
22     if (s != 0)
23         errExitEN(s, "getpwnam_r");
24
25     if (result != NULL)
26         printf("Name: %s\n", pwd.pw_gecos);
27     else
28         printf("Not found\n");
29
30     exit(EXIT_SUCCESS);
31 }
