/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Solution for Exercise 50-2 */

 1 #ifdef __linux__
 2 #define _BSD_SOURCE
 3 #endif
 4 #include <sys/mman.h>
 5 #include <sys/stat.h>
 6 #include <fcntl.h>
 7 #include "tlpi_hdr.h"
 8
 9 #define MAP_SIZE 4096
10 #define WRITE_SIZE 10
11
12 int
13 main(int argc, char *argv[])
14 {
15     char *addr;
16     int fd, j;
17
18     setbuf(stdout, NULL);
19
20     if (argc != 2 || strcmp(argv[1], "--help") == 0)
21         usageErr("%s file\n", argv[0]);
22
23     unlink(argv[1]);
24     fd = open(argv[1], O_RDWR | O_CREAT, S_IRUSR | S_IWUSR);
25     if (fd == -1)
26         errExit("open");
27
28     for (j = 0; j < MAP_SIZE; j++)
29         write(fd, "a", 1);
30     if (fsync(fd) == -1)
31         errExit("fsync");
32     close(fd);
33
34     fd = open(argv[1], O_RDWR);
35     if (fd == -1)
36         errExit("open");
37
38     addr = mmap(NULL, MAP_SIZE, PROT_READ | PROT_WRITE, MAP_PRIVATE, fd, 0);
39     if (addr == MAP_FAILED)
40         errExit("mmap");
41
42     printf("After mmap:          ");
43     write(STDOUT_FILENO, addr, WRITE_SIZE);
44     printf("\n");
45
46     /* Copy-on-write semantics mean that the following modification
47        will create private copies of the pages for this process */
48
49     for (j = 0; j < MAP_SIZE; j++)
50         addr[j]++;
51
52     printf("After modification:  ");
53     write(STDOUT_FILENO, addr, WRITE_SIZE);
54     printf("\n");
55
56     /* After the following, the mapping contents revert to the original file
57        contents (if MADV_DONTNEED has destructive semantics, as on Linux) */
58
59     if (madvise(addr, MAP_SIZE, MADV_DONTNEED) == -1)
60         errExit("madvise");
61
62     printf("After MADV_DONTNEED: ");
63     write(STDOUT_FILENO, addr, WRITE_SIZE);
64     printf("\n");
65
66     exit(EXIT_SUCCESS);
67 }
