/*************************************************************************\
*                  Copyright (C) Michael Kerrisk, 2014.                   *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Affero General Public License as published   *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
* See the file COPYING.agpl-v3 for details.                               *
\*************************************************************************/

/* Listing 50-1 */

 1 #define _BSD_SOURCE         /* Get MAP_ANONYMOUS definition from <sys/mman.h> */
 2 #include <sys/mman.h>
 3 #include "tlpi_hdr.h"
 4
 5 #define LEN (1024 * 1024)
 6
 7 #define SHELL_FMT "cat /proc/%ld/maps | grep zero"
 8 #define CMD_SIZE (sizeof(SHELL_FMT) + 20)
 9                             /* Allow extra space for integer string */
10
11 int
12 main(int argc, char *argv[])
13 {
14     char cmd[CMD_SIZE];
15     char *addr;
16
17     /* Create an anonymous mapping with all access denied */
18
19     addr = mmap(NULL, LEN, PROT_NONE, MAP_SHARED | MAP_ANONYMOUS, -1, 0);
20     if (addr == MAP_FAILED)
21         errExit("mmap");
22
23     /* Display line from /proc/self/maps corresponding to mapping */
24
25     printf("Before mprotect()\n");
26     snprintf(cmd, CMD_SIZE, SHELL_FMT, (long) getpid());
27     system(cmd);
28
29     /* Change protection on memory to allow read and write access */
30
31     if (mprotect(addr, LEN, PROT_READ | PROT_WRITE) == -1)
32         errExit("mprotect");
33
34     printf("After mprotect()\n");
35     system(cmd);                /* Review protection via /proc/self/maps */
36
37     exit(EXIT_SUCCESS);
38 }
